unit Auto;
(*
  Esimerkki
   1) TImageListin kytst
   2) TPaintBoxin perimisest
   3) TBitMapin kytst (mm. peilaaminen y-akselin suhteen)
   4) Viestin lhettmisest (Event) omistajalle
       - auto lhett aina liikahtaessaan viestin
       - auto lhettn viestin kun se kntyy

   Vesa Lappalainen 23.10.1997

   Changed  : 5.11.1999/vl
    + peritty TSpritest
   Changed  : 14.11.1999/vl
    + korjattu React-metodia
    + korjattu PaintTo-metodia siten, etta suunta ptetn suunnasta, ei dx:st
    + listty AutoReact perittvksi paremmin

   Changed  : 08.09.2001/vl
    + VCL/CLX-knns
    + entinen TAuto muutettu TLiikkuva ja TAuto peritn TLiikkuvasta
*)
interface

uses
  Classes,sprite,moving;

type

  TAuto = class(TMovingSprite)
  private
    FRemoveOnHit : boolean;
  public
    constructor Create(AOwner:TComponent); override;
    function MovingReact(sprite: TSprite): boolean; override;
    function IsRemovable(sprite:TSprite):boolean; virtual;
    property RemoveOnHit : boolean read FRemoveOnHit write FRemoveOnHit default true;
  end;


implementation


constructor TAuto.Create(AOwner: TComponent);
begin
  FRemoveOnHit := true;
  inherited;
end;

function TAuto.IsRemovable(sprite: TSprite): boolean;
begin
  Result := false;
  if not ( sprite is TAuto ) then exit;
  if not RemoveOnHit then exit;
  if not TAuto(sprite).RemoveOnHit then exit;
  Result := true;
end;

function TAuto.MovingReact(sprite: TSprite): boolean;
begin
  Result := true;
  if not IsRemovable(sprite) then exit;
  parent.UnJoin(self,true);
  parent.UnJoin(sprite,true);
end;

end.
