unit AutoPeliForm;
(*
  Esimerkki
    1) Liikkuvan auton kytst
    2) Olion dynaamisesta luomisesta
    3) Olion lhettmn omatekoisen viestin vastaanottamisesta

  Tarvitsee toimiakseen
    AutoPeliForm.pas - tm tiedosto
    sprite.pas       - kantalauokka koko liikuttelulle
    liikkuva.pas     - TSpritest peritty liikkuva olio
    auto.pas         - TLiikkuvast peritty auto
    traffic.pas      - liikennevalot
    rusinaauto.pas   - auto joka syttyy palamaan ja kutistuu rusinaksi
    driversbrain.pas - autoon ly, joka osaa reagoida liikennevaloihin

  Vesa Lappalainen 14.11.1999

  08.09.2001/vl
  + VCL/CLX -knns (mrittele vakio CLX)
*)
interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QExtCtrls,QStdCtrls,
{$else}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, ExtCtrls,StdCtrls,
{$endif}
  Auto,sprite, traffic, DriversBrain, rusinaauto;

type
  TFormAutoPeli = class(TForm)
    PanelOptions: TPanel;
    EditAutoja: TEdit;
    LabelAutoja: TLabel;
    LabelKA: TLabel;
    EditKA: TEdit;
    LabelLV: TLabel;
    EditLV: TEdit;
    ButtonUusi: TButton;
    LabelPaloPros: TLabel;
    EditPaloPros: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure AutoMove(sender:TAuto);
    procedure KAutoChangeDir(sender: TObject; dir: Integer);
    procedure EditAutojaEnter(Sender: TObject);
    procedure ButtonUusiClick(Sender: TObject);
  private
    Auto : TAuto;
    space : TSpriteSpace;
  public
    procedure Uusi;
  end;

var
  FormAutoPeli: TFormAutoPeli;

implementation
uses vclclx;

{$R *.dfm}

procedure TFormAutoPeli.FormCreate(Sender: TObject);
begin
  Randomize();
  uusi;
  FormCaption(self);
end;

procedure TFormAutoPeli.AutoMove(sender:TAuto);
begin
//
end;

procedure TFormAutoPeli.KAutoChangeDir(sender: TObject; dir: Integer);
begin
//
end;

procedure TFormAutoPeli.EditAutojaEnter(Sender: TObject);
begin
  if not ( sender is TEdit ) then exit;
  TEdit(Sender).SelectAll;
end;

function Num(e:TEdit;m:integer=40):integer;
begin
  Result := StrToIntDef(e.text,1);
  if ( Result > m ) then Result := m;
end;

procedure TFormAutoPeli.Uusi;
var i:integer;  tl : TTrafficLights; n:integer;
begin
  Randomize();
  space := TSpriteSpace.Create(self);
  space.Parent := self;
  space.Align := alClient;
  n := Num(EditAutoja,300)+Num(EditKa,300);
  for i:=0 to n-1 do begin
    Auto := TRusinaksiMuuttuvaAuto.Create(space);
    TDriversBrain.Create(Auto);
    Auto.x := Random(Space.ClientWidth-50);
    Auto.y := Random(Space.ClientHeight-20);
  //  Auto.Parent := self;
    if ( Random(n) > Num(EditKA) ) then
      Auto.BitName := 'Hauto.bmp'
    else
      Auto.BitName := 'kauto.bmp';
    Auto.Speed := Random(20)+1;
    Auto.RemoveOnHit := Random(100) < Num(EditPaloPros,100); // n% todennkisyys olla syttymtt
    if ( Random(100) > 80 ) then // 20 % todennkisyydell "vinoon" liikkuva
    Auto.Direction := Random(360);
//    Auto.OnAutoMove := AutoMove;
//    Auto.OnChangeDir := KAutoChangeDir;
  end;

  for i:=0 to Num(EditLV,40)-1 do begin
    tl := TTrafficLights.Create(space);
    tl.x := Random(Space.ClientWidth-50);
    tl.y := Random(Space.ClientHeight-20);
    tl.Interval := 40 + Random(100);
  end;

  Space.Interval := 100;
  Space.Running := true;
end;

procedure TFormAutoPeli.ButtonUusiClick(Sender: TObject);
begin
  Space.Running := false;
  Space.Free;
  Uusi;
end;

end.
